Bug Hunting Session
Bug 75518 - UI: Add "Print to File (PDF)" to list of printers in Print dialog
Summary: UI: Add "Print to File (PDF)" to list of printers in Print dialog
Status: RESOLVED WONTFIX
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Printing and PDF export (show other bugs)
Version:
(earliest affected)
4.2.0.4 release
Hardware: All All
: lowest enhancement
Assignee: Not Assigned
URL:
Whiteboard:
Keywords: needsDevEval, topicUI
Depends on:
Blocks:
 
Reported: 2014-02-26 02:55 UTC by dg1727
Modified: 2015-12-16 05:30 UTC (History)
7 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description dg1727 2014-02-26 02:55:14 UTC
This enhancement request is Linux-oriented, but I'm not sure that it would be a problem if it were implemented for Windows and MacOS too.  

Typical Linux applications (Web browsers, e-mail programs, text editors, even programs like Inkscape & Dia that have explicit PDF export commands) have "Print to File" (which includes PDF) as one of the printers listed in the Print dialog.  

If a user has been working in some of those other applications and then switches to LO and wants to export a document to PDF, the first impulse is to choose File > Print... and select the "Print to File" option ... but there's no such option in the Print dialog ... so the user then has to close the Print dialog and click the "Export Directly as PDF" button or choose File > Export as PDF...  

The enhancement request is to add an entry for "Export as PDF" to the list of printers in the Print dialog.  (I used the LO wording, "Export as PDF," rather than the GTK wording of "Print to File," because it may be easier to use existing UI elements from File > Export as PDF..., and those UI elements may differ from the GTK "Print to File" options.)  

The suggested enhancement may also occasionally help new users (on any OS) who want to produce a PDF and don't at first notice the existing "Export as PDF" options.
Comment 1 Jorendc 2014-06-24 12:42:29 UTC
(1) We clearly have a menu button by default in the toolbar to export as PDF, we do have a menu entry 'export to PDF'. Plus the 'Export to PDF' menu entry comes before the 'print' menu entry in 'File'. So if you are completely new you'll notice.

(2) In Mac OSX 10.9 the print dialog do have a button on the left bottom of the print dialog with 'PDF' on it.

(3) I can recall in Linux and Windows there is an option in one of the tabs 'Print to File'.

So I don't agree having again more buttons/entries for the same thing. I think it is already obvious enough. This will only clutter menu's and dialogs more.
Comment 2 dg1727 2014-11-25 03:02:04 UTC
There seem to be a few misunderstandings about this enhancement request.  Can my comments below be considered?:  

(In reply to Jorendc from comment #1)
> (1) We clearly have a menu button by default in the toolbar to export as
> PDF, we do have a menu entry 'export to PDF'. Plus the 'Export to PDF' menu
> entry comes before the 'print' menu entry in 'File'. So if you are
> completely new you'll notice.

Rather than for completely new users, my concern is about the ergonomics for more experienced users.  Those users might be rapidly switching between other applications, printing to PDF the same way in application after application; then they need to make a PDF from LibreOffice and have to "switch gears" unexpectedly.  (I've been in this situation, which is why I filed this request.)  The Print dialog can be invoked by shortcuts like Ctrl-P, in which case the user is likely not to be reminded of the PDF icons in the toolbar or menu.  

As I noted originally, LibreOffice wouldn't be the first major libre application to have both (1) a separate "Export to PDF" (or similar) and (2) [at least on Linux] PDF integration into the main printers list in the File > Print dialog.  

> (2) In Mac OSX 10.9 the print dialog do have a button on the left bottom of
> the print dialog with 'PDF' on it.

I'm glad this feature is in MacOS X.  I hope the Linux print dialog can also have a plainly available option for PDF printing, preferably the same way it is commonly done in Linux applications.  (I assume the Windows print dialog will easily get the feature along with the Linux dialog.)  

> (3) I can recall in Linux and Windows there is an option in one of the tabs
> 'Print to File'.

Yes, on the Options tab, there is a "Print to File" checkbox.  I think this is too hard to get at, compared to the PDF virtual printer that's available in many other Linux applications.  

> So I don't agree having again more buttons/entries for the same thing. I
> think it is already obvious enough. This will only clutter menu's and
> dialogs more.

I don't propose to add anything to any menu for this request, only to the Print dialog.  Also, the basic change needed for the requested feature is just to add an entry to the existing printer list; this doesn't involve adding any controls to the dialog at all.  There will probably also be code required to disable options that apply only to a physical printer, and to prompt for a folder path & filename (code already exists that does this when the "Print to File" checkbox is selected).  

If the requested entry in the printers list is implemented, it would be fine with me if the "Print to File" checkbox is removed.  

I read somewhere that it isn't preferred to reopen bugs.  If I should make a new bug with the clarifications above, please let me know.
Comment 3 Robinson Tryon (qubit) 2015-03-05 14:49:41 UTC
(In reply to dg1727 from comment #2)
> I read somewhere that it isn't preferred to reopen bugs.  If I should make a
> new bug with the clarifications above, please let me know.

'REOPENED' is reserved for bugs that have had a patch/fix from a developer.
Status -> UNCONFIRMED
Comment 4 Joel Madero 2015-03-06 05:49:25 UTC
Moving to NEW and requesting UX to get involved.
Comment 5 Adolfo Jayme 2015-08-13 14:13:18 UTC
In Windows 10, Microsoft have added a virtual printer called “Microsoft Print to PDF”. It’s not necessary to do anything there w.r.t. this bug.
Comment 6 Yousuf Philips (jay) (retired) 2015-08-16 21:08:25 UTC
The only OS i think this option might be useful for is on Linux, as the option to export to PDF isnt available as a virtual printer on Windows, which is why there are many free PDF printer drivers around (e.g. PrimoPDF, CutePDF, etc.). 

On Linux, there isnt a virtual pdf printer installed by default, though it is easy to install one by installing the cups-pdf package on Ubuntu. So with this in mind, and knowing that CUPS has this capability and is installed by default on most Linux systems, the gnome print dialog has a 'Print to File' option that exports as PDF, Postscript and SVG. Calligra is also aware of this and provides Print to File options for PDF and Postscript from its print dialog.

Not sure how useful it is to pursue this enhancement when it is quite limited in its scope, we provide direct access to pdf exporting, and it would likely involve quite a bit of development. So lets see what devs think about how easy this is to implement.
Comment 7 V Stuart Foote 2015-08-16 22:50:42 UTC
(In reply to Yousuf (Jay) Philips from comment #6)
> The only OS i think this option might be useful for is on Linux, as the
> option to export to PDF isnt available as a virtual printer on Windows,
> which is why there are many free PDF printer drivers around (e.g. PrimoPDF,
> CutePDF, etc.). 

Actually as Adolfo points out in Comment 5 -- Windows 10 now implements a virtual PDF print device, similar to their long present XPS.

> On Linux, there isnt a virtual pdf printer installed by default, though it
> is easy to install one by installing the cups-pdf package on Ubuntu. So with
> this in mind, and knowing that CUPS has this capability and is installed by
> default on most Linux systems, the gnome print dialog has a 'Print to File'
> option that exports as PDF, Postscript and SVG. Calligra is also aware of
> this and provides Print to File options for PDF and Postscript from its
> print dialog.

Yes printing on all Linux flavors I'm familiar with is CUPS based, which makes use of ghostscript--so PDF is derived there. Earlier Windows PDF printers do similar, just bundled for Windows.  Now with "native" PDF support at Windows 10.
> 
> Not sure how useful it is to pursue this enhancement when it is quite
> limited in its scope, we provide direct access to pdf exporting, and it
> would likely involve quite a bit of development. So lets see what devs think
> about how easy this is to implement.

IMHO, the existing menu "Export as PDF" using LibreOffice filters is sufficient. Also, no need to add either a Print to File, or change the existing Print dialog which includes either the OS provided, or an installed PDF printer (e.g. CutePDF or Adobe Distiller).
Comment 8 Heiko Tietze 2015-08-17 06:20:20 UTC
I would remove the explicit 'Export to PDF' in favor of this proposal. For the Eve's, we could keep the .uno-exportpdf whatever command in order to allow individualization of toolbar/menu.
Comment 9 Maxim Monastirsky 2015-08-17 07:04:19 UTC
(In reply to Adolfo Jayme from comment #5)
> In Windows 10, Microsoft have added a virtual printer called “Microsoft
> Print to PDF”. It’s not necessary to do anything there w.r.t. this bug.
Printing to virtual PDF printer is not the same as exporting to pdf. I believe there are many PDF features that we support, that are not possible to do with "printing", as it only outputs how the page look, the same way it outputs to a real printer.
Comment 10 Yousuf Philips (jay) (retired) 2015-08-17 16:20:44 UTC
(In reply to V Stuart Foote from comment #7)
> Actually as Adolfo points out in Comment 5 -- Windows 10 now implements a
> virtual PDF print device, similar to their long present XPS.

Yes i had read adolfo's comment 5, but saying that it is on Windows when its only available in the latest version of the OS doesnt fully mean it is available on Windows. If the feature isnt available to atleast 50% of Windows users, it is not really available on Windows. If a feature was only on OpenSUSE, i could state that its available on Linux, but how accurate is that statement. :)
Comment 11 Robinson Tryon (qubit) 2015-12-16 05:30:50 UTC
Migrating Whiteboard tags to Keywords: (needsDevEval, topicUI)
[NinjaEdit]